package CalculiX;

class EIf extends Expression {

  // The condition.
  final Expression condition;
  // The branches.
  final Expression then_branch, else_branch;

  EIf (Expression condition, Expression then_branch, Expression else_branch)
  {
    this.condition = condition;
    this.then_branch = then_branch;
    this.else_branch = else_branch;
  }

  Value eval (Environment env) throws EvalException
  {
    // Evaluate the condition. We expect it to produce a Boolean value.
    // According to this condition, evaluate the appropriate branch.
    if (condition.eval(env).asBoolean())
      return then_branch.eval(env);
    else
      return else_branch.eval(env);
  }

}
