package CalculiX;

// A trivial implementation of the interface ExpressionFactory.

// Each method simply invokes the constructor of the appropriate
// sub-class of the abstract class Expression.

class MyExpressionFactory implements ExpressionFactory {

  public Expression buildConstant (int i)
  {
    return new EConstant (i);
  }

  public Expression buildConstant (boolean b)
  {
    return new EConstant (b);
  }

  public Expression buildIntegerOperation (Expression left, Operator op, Expression right)
  {
    return new EIntegerOperation (left, op, right);
  }

  public Expression buildBooleanOperation (Expression left, Connective op, Expression right)
  {
    return new EBooleanOperation (left, op, right);
  }

  public Expression buildBooleanNegation (Expression e)
  {
    return new EBooleanOperation (e, Connective.XOR, new EConstant (true));
  }

  public Expression buildIntegerComparison (Expression left, Comparator op, Expression right)
  {
    return new EIntegerComparison (left, op, right);
  }

  public Expression buildIf (Expression condition, Expression then_branch, Expression else_branch)
  {
    return new EIf (condition, then_branch, else_branch);
  }

  public Expression buildLet (String x, Expression left, Expression right)
  {
    return new ELet (x, left, right);
  }

  public Expression buildVarRead (String x)
  {
    return new EVarRead (x);
  }

  public Expression buildSigma  (String x, Expression lo, Expression hi, Expression body)
  {
    return new ESigma  (x, lo, hi, body);
  }

}
